]> asedeno.scripts.mit.edu Git - git.git/blob - git-stash.sh
Make sure git-stash works from subdirectory.
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 USAGE='[ | list | show | apply | clear]'
5
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 require_work_tree
9 cd_to_toplevel
10
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
13
14 ref_stash=refs/stash
15
16 no_changes () {
17         git diff-index --quiet --cached HEAD &&
18         git diff-files --quiet
19 }
20
21 clear_stash () {
22         logfile="$GIT_DIR/logs/$ref_stash" &&
23         mkdir -p "$(dirname "$logfile")" &&
24         : >"$logfile"
25 }
26
27 save_stash () {
28         stash_msg="$1"
29
30         if no_changes
31         then
32                 echo >&2 'No local changes to save'
33                 exit 0
34         fi
35         test -f "$GIT_DIR/logs/$ref_stash" ||
36                 clear_stash || die "Cannot initialize stash"
37
38         # state of the base commit
39         if b_commit=$(git rev-parse --verify HEAD)
40         then
41                 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
42         else
43                 die "You do not have the initial commit yet"
44         fi
45
46         if branch=$(git symbolic-ref -q HEAD)
47         then
48                 branch=${branch#refs/heads/}
49         else
50                 branch='(no branch)'
51         fi
52         msg=$(printf '%s: %s' "$branch" "$head")
53
54         # state of the index
55         i_tree=$(git write-tree) &&
56         i_commit=$(printf 'index on %s' "$msg" |
57                 git commit-tree $i_tree -p $b_commit) ||
58                 die "Cannot save the current index state"
59
60         # state of the working tree
61         w_tree=$( (
62                 rm -f "$TMP-index" &&
63                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
64                 GIT_INDEX_FILE="$TMP-index" &&
65                 export GIT_INDEX_FILE &&
66                 git read-tree -m $i_tree &&
67                 git add -u &&
68                 git write-tree &&
69                 rm -f "$TMP-index"
70         ) ) ||
71                 die "Cannot save the current worktree state"
72
73         # create the stash
74         if test -z "$stash_msg"
75         then
76                 stash_msg=$(printf 'WIP on %s' "$msg")
77         else
78                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
79         fi
80         w_commit=$(printf '%s\n' "$stash_msg" |
81                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
82                 die "Cannot record working tree state"
83
84         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
85                 die "Cannot save the current status"
86         printf >&2 'Saved "%s"\n' "$stash_msg"
87 }
88
89 have_stash () {
90         git rev-parse --verify $ref_stash >/dev/null 2>&1
91 }
92
93 list_stash () {
94         have_stash || return 0
95         git log --pretty=oneline -g "$@" $ref_stash |
96         sed -n -e 's/^[.0-9a-f]* refs\///p'
97 }
98
99 show_stash () {
100         flags=$(git rev-parse --no-revs --flags "$@")
101         if test -z "$flags"
102         then
103                 flags=--stat
104         fi
105         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
106
107         w_commit=$(git rev-parse --verify "$s") &&
108         b_commit=$(git rev-parse --verify "$s^") &&
109         git diff $flags $b_commit $w_commit
110 }
111
112 apply_stash () {
113         git diff-files --quiet ||
114                 die 'Cannot restore on top of a dirty state'
115
116         unstash_index=
117         case "$1" in
118         --index)
119                 unstash_index=t
120                 shift
121         esac
122
123         # current index state
124         c_tree=$(git write-tree) ||
125                 die 'Cannot apply a stash in the middle of a merge'
126
127         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
128         w_tree=$(git rev-parse --verify "$s:") &&
129         b_tree=$(git rev-parse --verify "$s^:") ||
130                 die "$*: no valid stashed state found"
131
132         test -z "$unstash_index" || {
133                 git diff --binary $s^2^..$s^2 | git apply --cached
134                 test $? -ne 0 &&
135                         die 'Conflicts in index. Try without --index.'
136                 unstashed_index_tree=$(git-write-tree) ||
137                         die 'Could not save index tree'
138                 git reset
139         }
140
141         eval "
142                 GITHEAD_$w_tree='Stashed changes' &&
143                 GITHEAD_$c_tree='Updated upstream' &&
144                 GITHEAD_$b_tree='Version stash was based on' &&
145                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
146         "
147
148         if git-merge-recursive $b_tree -- $c_tree $w_tree
149         then
150                 # No conflict
151                 a="$TMP-added" &&
152                 git diff --cached --name-only --diff-filter=A $c_tree >"$a" &&
153                 git read-tree --reset $c_tree &&
154                 git update-index --add --stdin <"$a" ||
155                         die "Cannot unstage modified files"
156                 git-status
157                 rm -f "$a"
158                 test -z "$unstash_index" || git read-tree $unstashed_index_tree
159         else
160                 # Merge conflict; keep the exit status from merge-recursive
161                 status=$?
162                 test -z "$unstash_index" || echo 'Index was not unstashed.' >&2
163                 exit $status
164         fi
165 }
166
167 # Main command set
168 case "$1" in
169 list)
170         shift
171         if test $# = 0
172         then
173                 set x -n 10
174                 shift
175         fi
176         list_stash "$@"
177         ;;
178 show)
179         shift
180         show_stash "$@"
181         ;;
182 apply)
183         shift
184         apply_stash "$@"
185         ;;
186 clear)
187         clear_stash
188         ;;
189 help | usage)
190         usage
191         ;;
192 *)
193         if test $# -gt 0 && test "$1" = save
194         then
195                 shift
196         fi
197         save_stash "$*" && git-reset --hard
198         ;;
199 esac